<script>
import Vue from 'vue';
import { CarouselWrap } from '../common/index.vue';
import { numberToDigitString } from '~/common/util';

export default Vue.extend({
  name: 'OpenSourceBlog',
  components: { CarouselWrap },
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      step: 0,
      groupedEntries: this.getGroupedEntries(),
    };
  },
  computed: {
    formattedStep() {
      return `${numberToDigitString(this.step + 1)} - ${numberToDigitString(
        this.groupedEntries.length,
      )}`;
    },
  },
  mounted() {},
  methods: {
    getGroupedEntries() {
      const entries = [...this.data.entries];
      const arrays = [];
      while (entries.length > 0) {
        arrays.push(entries.splice(0, 3));
      }
      return arrays;
    },
    goNext() {
      this.$refs.carousel.next();
      this.step =
        this.step >= this.groupedEntries.length - 1 ? 0 : this.step + 1;
    },
    goPrev() {
      this.$refs.carousel.prev();
      this.step =
        this.step <= 0 ? this.groupedEntries.length - 1 : this.step - 1;
    },
  },
});
</script>

<template>
  <section
    class="open-source-blog"
    :class="{
      'no-background': data.no_background,
    }"
  >
    <SlpContainer>
      <SlpRow>
        <div class="open-source-blog__header">
          <div class="text">
            <SlpTypography
              v-if="data.header"
              tag="h2"
              variant="heading2-bold"
              class="slp-mb-16"
              ><span v-html="data.header"></span>
            </SlpTypography>
            <SlpTypography v-if="data.subheader" tag="h3" variant="heading5"
              ><span v-html="data.subheader"></span>
            </SlpTypography>
          </div>
          <SlpButton
            :href="data.link.url"
            variant="tertiary"
            tag="p"
            class="cta"
            >{{ data.link.text }}
            <SlpIcon name="chevron-lg-right" variant="product"
          /></SlpButton>
        </div>
        <div class="grid-container" :class="{ 'mobile-only': data.carousel }">
          <SlpCard100
            v-for="card in data.entries"
            :key="card.header"
            :link="card.link.href"
            class="blog-card slp-mr-32"
          >
            <div class="card-type">
              <SlpIcon
                :name="card.icon || 'blog'"
                variant="marketing"
                class="slp-mr-8"
                size="sm"
              />
              <SlpTypography variant="body2">{{
                card.type || 'Blog'
              }}</SlpTypography>
            </div>
            <nuxt-img :src="card.image" class="image slp-mb-24" />
            <SlpTypography class="description" variant="body1" tag="p">{{
              card.description
            }}</SlpTypography>

            <SlpButton
              class="learn-more"
              variant="tertiary"
              :href="card.link.href"
              >{{ card.link.text || 'Learn more' }}
              <SlpIcon name="chevron-lg-right" variant="product"
            /></SlpButton>
          </SlpCard100>
        </div>
        <CarouselWrap
          ref="carousel"
          class="carousel desktop-only"
          :class="{ disabled: !data.carousel }"
          :items="groupedEntries"
        >
          <template #content>
            <template v-if="$refs.carousel">
              <div
                v-for="entryNumber in $refs.carousel.itemIndexes"
                :key="`group-${entryNumber}`"
                class="group"
              >
                <SlpCard100
                  v-for="card in groupedEntries[entryNumber]"
                  :key="card.header"
                  :link="card.link"
                  class="blog-card"
                >
                  <div class="card-type">
                    <SlpIcon
                      :name="card.icon || 'blog'"
                      variant="marketing"
                      class="slp-mr-8"
                      size="sm"
                    />
                    <SlpTypography variant="body2">{{
                      card.type || 'Blog'
                    }}</SlpTypography>
                  </div>
                  <nuxt-img :src="card.image" class="image slp-mb-24" />
                  <SlpTypography class="description" variant="body1" tag="p">{{
                    card.description
                  }}</SlpTypography>

                  <SlpButton
                    class="learn-more"
                    variant="tertiary"
                    :href="card.link"
                    >Learn more
                    <SlpIcon name="chevron-lg-right" variant="product"
                  /></SlpButton>
                </SlpCard100>
              </div>
            </template>
          </template>
        </CarouselWrap>
        <div
          class="open-source-blog__footer desktop-only"
          :class="{ disabled: !data.carousel }"
        >
          <SlpTypography tag="span" variant="body1" class="quote-count">{{
            formattedStep
          }}</SlpTypography>
          <div>
            <SlpButton
              variant="icon"
              aria-label="Prev"
              @click.native="goPrev()"
            >
              <SlpIcon
                name="chevron-lg-left"
                variant="product"
                hex-color="#171321"
              />
            </SlpButton>
            <SlpButton
              variant="icon"
              aria-label="Next"
              @click.native="goNext()"
            >
              <SlpIcon
                class="slp-ml-8"
                name="chevron-lg-right"
                variant="product"
                hex-color="#171321"
              />
            </SlpButton>
          </div>
        </div>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.cta {
  align-self: flex-end;
  padding-left: 0;
  @media (max-width: $breakpoint-lg) {
    align-self: flex-start;
    margin-top: $spacing-16;
  }
}
.group {
  display: flex;
  align-items: center;
  min-width: 100%;
  justify-content: space-between;
}
.blog-card {
  display: flex;
  flex-direction: column;
  height: 100%;
  justify-content: flex-start;
  @media (max-width: $breakpoint-lg) {
    padding: 0;
    margin-right: $spacing-32;
  }
  @media (min-width: $breakpoint-lg) {
    justify-self: center;
  }
  .card-type {
    display: flex;
  }

  .description {
    flex: 1;
  }
}
.learn-more {
  padding-left: 0;
}
.open-source-blog {
  padding: $spacing-96 0;
  position: relative;

  &.no-padding {
    padding: 0;
  }

  @media (max-width: $breakpoint-md) {
    padding: $spacing-48 0;
  }

  &__header {
    display: flex;
    width: 100%;
    flex-direction: row;
    justify-content: space-between;
    padding-bottom: $spacing-32;
    border-bottom: 2px solid $color-surface-400;
    @media (max-width: $breakpoint-lg) {
      flex-direction: column;
    }
    .text {
      @media (min-width: $breakpoint-lg) {
        width: 75%;
      }
    }

    &:deep a {
      @media (max-width: $breakpoint-md) {
        padding-left: 0;
      }
    }
  }

  &__quote {
    display: inline-flex;
    margin-right: $spacing-16;
    flex: 0 0 100%;
    :deep .case-study-quote {
      margin-left: 0;
      justify-content: flex-start;
    }
  }

  &__footer {
    display: flex;
    width: 100%;
    align-items: center;
    padding: $spacing-16 0;
    .quote-count {
      margin-right: auto;
    }
  }
}
.desktop-only {
  @media (max-width: $breakpoint-lg) {
    display: none !important;
  }
}

.image {
  object-fit: contain;
  height: 200px;
  @media (min-width: $breakpoint-lg) {
    height: 235px;
    width: 275px;
    max-width: 100%;
  }
}

.disabled {
  display: none !important;
}
.grid-container {
  display: grid;
  padding: $spacing-32 0;
  grid-template-columns: repeat(3, 1fr);
  grid-gap: $spacing-32;
  border-bottom: 2px solid #a2a1a6;
  @media (max-width: $breakpoint-lg) {
    display: flex;
    grid-gap: 0;
    flex-wrap: nowrap;
    overflow: scroll;
    max-width: 100%;
  }
  &.mobile-only {
    @media (min-width: $breakpoint-lg) {
      display: none;
    }
  }
}
</style>
